---
title: Clipboard
slug: Web/API/Clipboard
tags:
  - API
  - Clip
  - Clipboard
  - Clipboard API
  - Cut
  - Editing
  - Interface
  - Pasteboard
  - Reference
  - copy
  - paste
---
<p>{{APIRef("Clipboard API")}}</p>

<p><span class="seoSummary">The <strong><code>Clipboard</code></strong> interface implements the <a href="/en-US/docs/Web/API/Clipboard_API">Clipboard API</a>, providing—if the user grants permission—both read and write access to the contents of the system clipboard.</span> The Clipboard API can be used to implement cut, copy, and paste features within a web application.</p>

<p>The system clipboard is exposed through the global {{domxref("Navigator.clipboard")}} property.</p>

<p>Calls to the methods of the <code>Clipboard</code> object will not succeed if the user hasn't granted the needed permissions using the <a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a> and the <code>"clipboard-read"</code> or <code>"clipboard-write"</code> permission as appropriate.</p>

<div class="note">
<p><strong>Note:</strong> In reality, at this time browser requirements for access to the clipboard vary significantly. Please see the section {{anch("Clipboard availability")}} for details.</p>
</div>

<p>All of the Clipboard API methods operate asynchronously; they return a {{jsxref("Promise")}} which is resolved once the clipboard access has been completed. The promise is rejected if clipboard access is denied.</p>

<div class="notecard note">
<p>The <strong>clipboard </strong>is a data buffer that is used for short-term, data storage and/or data transfers, this can be between documents or applications<br>
  It is usually implemented as an anonymous, temporary <a href="https://en.wikipedia.org/wiki/Data_buffer" title="Data buffer">data buffer</a>, sometimes called the paste buffer, that can be accessed from most or all programs within the environment via defined <a href="https://en.wikipedia.org/wiki/Application_programming_interface" title="Application programming interface">programming interfaces</a>.</p>

<p>A typical application accesses clipboard functionality by mapping <a href="https://en.wikipedia.org/wiki/User_input" title="User input">user input</a> such as <a href="https://en.wikipedia.org/wiki/Keybinding" title="Keybinding">keybindings</a>, <a href="https://en.wikipedia.org/wiki/Menu_(computing)" title="Menu (computing)">menu selections</a>, etc. to these interfaces.</p>
</div>

<h2 id="Methods">Methods</h2>

<p><em><code>Clipboard</code> is based on the {{domxref("EventTarget")}} interface, and includes its methods.</em></p>

<dl>
 <dt>{{domxref("Clipboard.read()","read()")}}</dt>
 <dd>Requests arbitrary data (such as images) from the clipboard, returning a {{jsxref("Promise")}}. When the data has been retrieved, the promise is resolved with a {{domxref("DataTransfer")}} object that provides the data.</dd>
 <dt>{{domxref("Clipboard.readText()","readText()")}}</dt>
 <dd>Requests text from the system clipboard; returns a <code>Promise</code> which is resolved with a {{domxref("DOMString")}} containing the clipboard's text once it's available.</dd>
 <dt>{{domxref("Clipboard.write()","write()")}}</dt>
 <dd>Writes arbitrary data to the system clipboard. This asynchronous operation signals that it's finished by resolving the returned <code>Promise</code>.</dd>
 <dt>{{domxref("Clipboard.writeText()","writeText()")}}</dt>
 <dd>Writes text to the system clipboard, returning a <code>Promise</code> which is resolved once the text is fully copied into the clipboard.</dd>
</dl>

<h2 id="Clipboard_availability">Clipboard availability</h2>

<p>The asynchronous clipboard API is a relatively recent addition, and the process of implementing it in browsers is not yet complete. Due to both potential security concerns and technical complexities, the process of integrating this API is happening gradually in most browsers.</p>

<p>For example, Firefox does not yet support the <code>"clipboard-read"</code> and <code>"clipboard-write"</code> permissions, so access to the methods that access and change the contents of the clipboard are restricted in other ways.</p>

<p>For WebExtensions, you can request the clipboardRead and clipboardWrite permissions to be able to use clipboard.readText() and clipboard.writeText(). Content scripts applied on HTTP sites do not have access to the clipboard object. See <a href="https://blog.mozilla.org/addons/2018/08/31/extensions-in-firefox-63/">extensions in Firefox 63</a>.</p>

<p>In addition, {{domxref("Clipboard.read", "read()")}} and {{domxref("Clipboard.write", "write()")}} are disabled by default and require changing a preference to enable them. Check the compatibility tables for each method before using it.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Clipboard API','#clipboard-interface','Clipboard')}}</td>
   <td>{{Spec2('Clipboard API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Clipboard")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Document.execCommand()")}}</li>
</ul>
